#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# Script para descargar archivos desde goear.
# Versión: 0.2
# Copyright (C) 2007 Daniel Fuentes <dbfuentes@gmail.com>

# Este programa es software libre: usted puede redistribuirlo y/o modificarlo bajo los términos de la Licencia Pública General GNU publicada por la Fundación para el Software Libre, ya sea la versión 3 de la Licencia, o (a su elección) cualquier versión posterior.

# Este programa se distribuye con la esperanza de que sea útil, pero SIN GARANTÍA ALGUNA; ni siquiera la garantía implícita MERCANTIL o de APTITUD PARA UN OBJETIVO PARTICULAR. Consulte los detalles de la Licencia Pública General GNU para mayor información.

# Debería haber recibido una copia de la Licencia Pública General GNU junto a este programa. En caso contrario, consulte <http://www.gnu.org/licenses/>.

# Importamos algunos módulos que luego usaremos en el script:

import sys
import urllib
import urllib2
from xml.dom import minidom

# El texto que se muestra en la ayuda

texto_ayuda = """Script para descargar archivos de goear
Modo de uso:
goear.py [Url u Opcion]

Donde en [Url u Opcion] se puede ingresar directamente la url del archivo o una de las
siguientes opciones

Opciones diponibles:
-h, --help          Muestra la ayuda
-v, --version       Muestra la version del programa.

Ejemplos:
goear.py http://www.goear.com/listen.php?v=xxxxxx  # Descarga el archivo desde esa url
goear.py --help                                    # Muestra esta ayuda

Para mayor información revise el archivo "README" """

# Comprobar si se ingreso algun dato en la linea de ordenes
# Si no se ingresa nada sys.argv solo tendra el nombre del script (goear.py)

if len(sys.argv) == 1: # El unico dato es goear.py (no hay ordenes o url)
    tengo_opciones = False
    audio_url = str(raw_input("Ingrese la dirección (url) del archivo: "))
else:
    tengo_opciones = True
    opcion = sys.argv[1]

# Opciones de la linea de comandos

if tengo_opciones:
    if opcion == "-h" or opcion == "--help" or opcion == "help" or opcion == "-help":      
        print texto_ayuda                    
        sys.exit()
    elif opcion == "-v" or opcion == "--version":
        print "Versión 0.2"
        sys.exit()
    else:
        audio_url = sys.argv[1]

# Encontrar la ID del archivo

inicio_id = audio_url.find("v=")
fin_id = len(audio_url)

audio_id = audio_url[inicio_id+2:fin_id]

# Abrir el archivo xml que contiene la información 
# de la forma http://www.goear.com/files/sst/secmxxyyzz.xml

url_xml = "http://www.goear.com/files/sst/secm" + audio_id + ".xml"
data = None

xmldoc = urllib2.urlopen(url_xml,data)
xml_data = minidom.parse(xmldoc)
xmldoc.close()
data = xml_data.toxml()

# Buscar la linea "song path=" que es la dirección del archivo

inicio_path = data.find("path=")
fin_path = data.find(".mp3")

path = data[inicio_path+6:fin_path+4]

# Definimos la función de descarga:

def download_file(filename, URL):
    f = urllib.urlretrieve(URL, filename, reporthook=my_report_hook)

# Definimos la función que muestra el progreso del archivo:

def my_report_hook (block_count, block_size, total_size): 
    total_kb  = total_size / 1024
    descargado = block_count * (block_size/1024)
    print "Descargados %d kb de %d kb" %(descargado,total_kb)

# Ahora hay que descargar el archivo:

if __name__ == "__main__":
   download_file("musica.mp3",path)

print "Listo, ahora solo abra el archivo llamado musica.mp3"
